#include "GISproto.h"

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoWWWInline.h>
#include <Inventor/Xt/SoXt.h>
#include <stdlib.h>
#include <iostream.h>

#include <Inventor/nodes/SoCone.h>

#include "SoXtWebViewer.h"
#include "WebCB.h"

int SOCK;

int
main( int argc, char* argv[] )
  {
     if( argc < 4 )
       {
	  cerr << "USAGE: " << argv[0] << " m|s w|f sockfd\n";
	  exit(1);
       }

     SOCK = atoi( argv[3] );
     
     Widget myWindow = SoXt::init( argv[0] );
     if( myWindow == NULL )
       {
	  cerr << "SoXt::init failed\n";
	  exit(1); 
       }

     // Callback registration
     RegisterURLCB();

     Viewer = new SoXtWebViewer( (*argv[1] == 'm')? MASTER : SLAVE,
				 (*argv[2] == 'w')? WALK : FLY,
				 myWindow  );
     SoSeparator* sep = new SoSeparator;
     sep->ref();
     Viewer->setSceneGraph( sep );
     if( argc < 5 )
       sep->addChild( new SoCone );
     else
       LoadGraph( argv[4],  Viewer );

     Viewer->show();
     SoXt::show( myWindow );
     SoXt::mainLoop();

     return 0;
  }
